#include <stdio.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include "polluxregs.h"

/* register access */
int memfd;
int isinit;
volatile uint32_t *memregs32;
volatile uint16_t *memregs16;
volatile uint8_t  *memregs8;
volatile uint16_t *uppermem;
uint32_t bkregs32[15];	/* backing up values */

void exit_buttons()
{
	/* restore old register values */
	MLCADDRESS0 = bkregs32[0];
	MLCADDRESS1 = bkregs32[1];
	MLCCONTROL0 = bkregs32[2];
	MLCCONTROL1 = bkregs32[3];
	MLCLEFTRIGHT0 = bkregs32[4];
	MLCTOPBOTTOM0 = bkregs32[5];
	MLCLEFTRIGHT1 = bkregs32[6];
	MLCTOPBOTTOM1 = bkregs32[7];
	MLCBGCOLOR = bkregs32[8];
	MLCHSTRIDE0 = bkregs32[9];
	MLCVSTRIDE0 = bkregs32[10];
	MLCHSTRIDE1 = bkregs32[11];
	MLCVSTRIDE1 = bkregs32[12];
	DPCCTRL1 = bkregs32[13];
	MLCSCREENSIZE = bkregs32[14];
	close(memfd);
};

void init_button_mapping()
{
	/* open /dev/mem to access registers */
	memfd = open("/dev/mem", O_RDWR);

	/* get access to the registers */
	memregs32 = (volatile uint32_t*)mmap(0, 0x20000, PROT_READ|PROT_WRITE, MAP_SHARED, memfd, 0xC0000000);
	memregs16 = (volatile uint16_t*)memregs32;
	memregs8 = (volatile uint8_t*)memregs32;

	/* map the upper memory */
	uppermem = (volatile uint16_t*)mmap(0, 0x12C000, PROT_READ|PROT_WRITE, MAP_SHARED, memfd, 0x3700000);

	/* backup old register values to restore upon exit */
	bkregs32[0] = MLCADDRESS0;
	bkregs32[1] = MLCADDRESS1;
	bkregs32[2] = MLCCONTROL0;
	bkregs32[3] = MLCCONTROL1;
	bkregs32[4] = MLCLEFTRIGHT0;
	bkregs32[5] = MLCTOPBOTTOM0;
	bkregs32[6] = MLCLEFTRIGHT1;
	bkregs32[7] = MLCTOPBOTTOM1;
	bkregs32[8] = MLCBGCOLOR;
	bkregs32[9] = MLCHSTRIDE0;
	bkregs32[10] = MLCVSTRIDE0;
	bkregs32[11] = MLCHSTRIDE1;
	bkregs32[12] = MLCVSTRIDE1;
	bkregs32[13] = DPCCTRL1;
	bkregs32[14] = MLCSCREENSIZE;
	std::atexit(exit_buttons);
};

enum {
	BTN_A = BIT(20),
	BTN_B = BIT(21),
	BTN_X = BIT(22),
	BTN_Y = BIT(23),
	BTN_L = BIT(7),
	BTN_R = BIT(6),
	BTN_MENU = BIT(9),
	BTN_SELECT = BIT(8),
	BTN_LEFT = BIT(16),
	BTN_RIGHT = BIT(17),
	BTN_UP = BIT(18),
	BTN_DOWN = BIT(19),
	BTN_VOLUP = BIT(10),
	BTN_VOLDOWN = BIT(11)
};
int get_button_state()
{
	return ~((GPIOCPAD << 16) | GPIOBPAD);
}
